package com.camunda.consulting.callActivityProcesses.nonarquillian;

import org.apache.ibatis.logging.LogFactory;
import org.camunda.bpm.engine.impl.util.LogUtil;
import org.camunda.bpm.engine.runtime.Execution;
import org.camunda.bpm.engine.runtime.Job;
import org.camunda.bpm.engine.runtime.ProcessInstance;
import org.camunda.bpm.engine.test.ProcessEngineRule;
import org.camunda.bpm.engine.test.Deployment;
import org.junit.Before;
import org.junit.Rule;
import org.junit.Test;

import static org.camunda.bpm.engine.test.assertions.ProcessEngineTests.*;

/**
 * Test case starting an in-memory database-backed Process Engine.
 */
public class FailingProcessTest {

  @Rule
  public ProcessEngineRule rule = new ProcessEngineRule();

  // enable more detailed logging
  static {
    LogUtil.readJavaUtilLoggingConfigFromClasspath(); // process engine
    LogFactory.useJdkLogging(); // MyBatis
  }
  
  @Before
  public void setup() {
	init(rule.getProcessEngine());
  }

  @Test
  @Deployment(resources = { "activityBehavior.bpmn" })
  public void failOnLeaveBehavior() {
    ProcessInstance pi = runtimeService().startProcessInstanceByKey("activityBehavior", "1001");
    assertThat(pi).isNotEnded();
    Job job = jobQuery().processInstanceId(pi.getId()).singleResult();
    execute(job);
    assertThat(pi).isNotEnded();
    Execution execution = runtimeService().createExecutionQuery().activityId("ServiceTask_1").singleResult();
    runtimeService().signal(execution.getId());
    
    assertThat(pi).isEnded();
  }
  
}
